#ifndef Face_h
#define Face_h

#include <qobject.h>
#include <qstring.h>
#include <qcanvas.h>
#include <qstring.h>
#include <qevent.h>
#include <kwinmodule.h>
#include <kwin.h>
#include <krandomsequence.h>

#include <ksgrd/SensorClient.h>
#include <ksgrd/SensorManager.h>
#include <qpopupmenu.h>
#include "SkinManager.h"

#define STRAIGHT_AHEAD 0
#define LOOKING_LEFT 1
#define LOOKING_RIGHT 2
#define GLANCING_LEFT 3
#define GLANCING_RIGHT 4
#define GROWLING 5
#define SURPRISED 6
#define GRINING 7

#define DEAD 8
#define DOPED 9

#define N_POLLS 4
#define CPUPOLL 8

class QTimer;



class Face : public QObject, public QCanvasSprite, public KSGRD::SensorClient {
  Q_OBJECT
 public:
  Face( SkinManager *manager,QCanvas *, QWidget * = 0, const char * = 0);
  ~Face();
  void advance(int phase);
  //void advance( int phase );
  int faceNumber(int type,int level);
  void changeFace(int type,int tics);
  void answerReceived( int, const QString& );


 public slots:
   void currentDesktopChanged(int d);
 void mouseEntered(QEvent *evt);
 void setPixmap(QCanvasPixmapArray *array);
 private:
  int timeout;
  int currentLevel;
  int currentType;
  int currentDesktop;
  int cpuTimeout;
  int cpuMedia;

  int userLoad;
  int sysLoad;
  int niceLoad;
  void adjustPosition();
  SkinManager *skinManager;
  
  KSGRD::SensorManager *sensorManager;
  QTimer *animTimer;
  QCanvas *container;
  KWinModule *winmodule;
  KRandomSequence *random;
  QWidget *appletView;
 protected slots:
   void resizeEvent( QResizeEvent *_Event);
   void windowAdded(WId w);
   void windowRemoved(WId w);
};

#endif
