#ifndef Skin_h
#define Skin_h

#include "Face.h"
#include <qstring.h>
#include <qobject.h>
#include <qdict.h>
#include <qstringlist.h>
#include <qdir.h>
#include <qcanvas.h>
#include <kconfig.h>
#include <kcolordialog.h>
#include <qcolor.h>


class SkinManager : public QObject {
Q_OBJECT 

 public:
  SkinManager(KConfig *c);
  ~SkinManager();
  QCanvasPixmapArray* getPixmap(QString skin);
  QStringList *getSkinNames();
  QString getDefaultSkin();
  QPopupMenu *getMenu();
  QColor getDefaultColor();
public slots:
  void changeSkin(int id);
   void changeColor();
signals:
  void skinChanged(QCanvasPixmapArray *array);
  void colorChanged(QColor color);

 private:
  void loadSkinNames();
  void initMenu();
  void fillMenus();
  QDict<QCanvasPixmapArray> *skinsHash;
  QStringList *skinsList;
  QDir *skinsDir;
  QPopupMenu *menu;
  QPopupMenu *skinsMenu;
  KConfig *config;


};

#endif
