/***************************************************************************
                          karmack.cpp  -  description
                             -------------------
    begin                : Sat Aug 30 11:15:34 CEST 2003
    copyright            : (C) 2003 by Sergio GARCIA
    email                : sergio@senna
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <kglobal.h>
#include <klocale.h>
#include <kconfig.h>
#include <kapp.h>
#include <kdebug.h>
#include <kmessagebox.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qcolor.h>
#include <kdebug.h>
#include <qvbox.h>
#include <qcursor.h>
#include <kaboutapplication.h>
#include "karmack.h"
#include "Face.h"
#include "SkinManager.h"
#include <kaboutdata.h>
#include <kstandarddirs.h>
#include <qpopupmenu.h>
#include <kconfig.h>

extern "C"
{
  KPanelApplet* init( QWidget *parent, const QString configFile)
  {
    KGlobal::locale()->insertCatalogue("karmack");
    return new Karmack(configFile, KPanelApplet::Normal,
                      KPanelApplet::About ,
                      parent, "Karmack");
  }
}

Karmack::Karmack(const QString& configFile, Type type, int actions, QWidget *parent, const char *name) 
       : KPanelApplet(configFile, type, actions, parent, name)
{

  ksConfig = config();
  resize(200,200);

  // start canvas, where i'll show the face
  canvas = new QCanvas( this, "Canvas" );
  canvas->resize(200,200);
  canvas->setAdvancePeriod(ADVANCE_PERIOD);

  canvasView = new QCanvasView( canvas, this, "CanvasView" );
  canvasView -> setCanvas( canvas );
  KStandardDirs *stddirs = new KStandardDirs();
  QString picsdir = stddirs->findResourceDir("data","karmack/skins/doom/0000.gif");
  QString pixmapexp = picsdir + "karmack/skins/doom/%1.gif";
  kdDebug() << pixmapexp << "\n";
  manager = new SkinManager(config());
  if (manager->getPixmap(manager->getDefaultSkin())->isValid()) {
    canvas->setBackgroundColor(manager->getDefaultColor());
    face = new Face(manager,canvas,this,"bj");
    //face = new Face(new QCanvasPixmapArray(),manager,canvas,this,"bj");
    canvasView -> resize(width(),height());
    //canvasView->show();
    canvasView->setVScrollBarMode(QScrollView::AlwaysOff);
    canvasView->setHScrollBarMode(QScrollView::AlwaysOff);
  
    
    connect(this,SIGNAL(resized(QResizeEvent *)),face,SLOT(resizeEvent(QResizeEvent *)));
    connect(this,SIGNAL(mouseEntered(QEvent *)),face,SLOT(mouseEntered(QEvent *)));
  
    connect(manager,SIGNAL(colorChanged(QColor)),this,SLOT(changeColor(QColor)));
    // Set the customMenu
    
    
    //setCustomMenu(manager->getMenu());
  }
}

Karmack::~Karmack(){
  delete canvas;
  delete canvasView;
}

void Karmack::about()
{
  KAboutData aboutData("karmack", "Karmack", 
		       "1.0",
		       "Doom nostalgy applet.\n"
		       "\"Where the sanest place is behind a keyboard\"",
		       KAboutData::License_GPL_V2, "2003 Sergio Garcia");
   
  aboutData.addAuthor("Sergio Garcia", "Mantainer", "sergio.garcia@imag.fr");
  
  KAboutApplication dialog(&aboutData, this);
  dialog.exec();
}

void Karmack::help()
{
   KMessageBox::information(0, i18n("This is a help box"));
}

void Karmack::preferences()
{
   KMessageBox::information(0, i18n("This is a preferences box"));  
}

int Karmack::widthForHeight( int height ) const
{
  return height;
}

int Karmack::heightForWidth( int width ) const
{ 
  return width;
}

void Karmack::resizeEvent( QResizeEvent *_Event)
{
  emit resized(_Event);
}

void Karmack::enterEvent ( QEvent * evt) {
  emit mouseEntered(evt);
  //face->mouseEntered(evt);
}


void Karmack::mousePressEvent( QMouseEvent* ev ) {
	//kdDebug()<<"ArtsControlApplet::mousePressEvent( QMouseEvent* "<<ev<<" )"<<endl;
  if (Qt::RightButton == ev->button()) {
    manager->getMenu()->exec(QCursor::pos());
    //p->menu->exec( QCursor::pos() );
  }
}

void Karmack::changeColor(QColor color){
  canvas->setBackgroundColor(color);  
}

#include "karmack.moc"

